@ Asm 16Bits Blur . by Orion_ [2004]
@
@ Reference it from C by using:
@  extern void DoBlur (unsigned char *src, unsigned char *dest);
@
@ Entry:
@  r0 = src, r1 = dest

@ sans Blur       : 5.6s
@ avec Blur (old) : 9.8s
@ sans Blur (new) : 9.6s

	.ALIGN
	.GLOBAL DoSoftBlur
	.TYPE   DoSoftBlur, function

DoSoftBlur:
	stmfd	r13!,{r4,r5,r6}
	mov	r2,#37
	mov	r12,r2,lsl #11
	add	r12,r12,#544		@ r12=(37*2048)+544=318*240=76320 why this weird operation ? because #76320 dont work

					@ r0=source 1 (-240)
	mov	r2,r0			@ r2=source 2 (-1)
	add	r2,r2,#960

	add	r1,r1,#480		@ next destination line

BlurLoop:
	mov	r4,#0			@ Clear just to be sure
	mov	r5,#0
	mov	r6,#0

	ldrh	r3,[r0],#2		@ Load the 16Bits color 1 *(p++)
	mov	r4,r3,lsr #1		@ B
	mov	r5,r3,lsr #6		@ G
	mov	r6,r3,lsr #11		@ R
	and	r4,r4,#31		@ isole les couleurs
	and	r5,r5,#31
	and	r6,r6,#31

	ldrh	r3,[r2],#2		@ Load the 16Bits color 2 *(p++)
	mov	r3,r3,lsr #1
	and	r3,r3,#31
	add	r4,r4,r3		@ +B
	mov	r3,r3,lsr #5
	and	r3,r3,#31
	add	r5,r5,r3		@ +G
	mov	r3,r3,lsr #5
	and	r3,r3,#31
	add	r6,r6,r3		@ +R

	mov	r4,r4,lsr #1		@ Divide by 2 (color1+color2)/2
	mov	r5,r5,lsr #1		@ + highlight
	mov	r6,r6,lsr #1
	cmp	r4,#31
	movhi	r4,#31
	cmp	r5,#31
	movhi	r5,#31
	cmp	r6,#31
	movhi	r6,#31
	and	r4,r4,#31		@ isole les couleurs
	and	r5,r5,#31
	and	r6,r6,#31

	mov	r3,#0			@ Clear just to be sure
	mov	r3,r4,lsl #1		@ recompose the final color
	orr	r3,r3,r5,lsl #6
	orr	r3,r3,r6,lsl #11

	strh	r3,[r1],#2		@ put the final color

	subs	r12,r12,#1
	bne	BlurLoop

	ldmfd	r13!,{r4,r5,r6}
	bx	lr
.fend1:
	.SIZE DoSoftBlur, .fend1-DoSoftBlur
